您的位置:首页 > 其它

hdu 2614 Beat

2014-08-26 18:28 127 查看


Beat

Time Limit: 6000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 602 Accepted Submission(s): 390



Problem Description

Zty is a man that always full of enthusiasm. He wants to solve every kind of difficulty ACM problem in the world. And he has a habit that he does not like to solve

a problem that is easy than problem he had solved. Now yifenfei give him n difficulty problems, and tell him their relative time to solve it after solving the other one.

You should help zty to find a order of solving problems to solve more difficulty problem.

You may sure zty first solve the problem 0 by costing 0 minute. Zty always choose cost more or equal time’s problem to solve.

Input

The input contains multiple test cases.

Each test case include, first one integer n ( 2< n < 15).express the number of problem.

Than n lines, each line include n integer Tij ( 0<=Tij<10), the i’s row and j’s col integer Tij express after solving the problem i, will cost Tij minute to solve the problem j.

Output

For each test case output the maximum number of problem zty can solved.

Sample Input

3
0 0 0
1 0 1
1 0 0
3
0 2 2
1 0 1
1 1 0
5
0 1 2 3 1
0 0 2 3 1
0 0 0 3 1
0 0 0 0 2
0 0 0 0 0


Sample Output

3
2
4
Hint
Hint: sample one, as we know zty always solve problem 0 by costing 0 minute.
So after solving problem 0, he can choose problem 1 and problem 2, because T01 >=0 and T02>=0.
But if zty chooses to solve problem 1, he can not solve problem 2, because T12 < T01.
So zty can choose solve the problem 2 second, than solve the problem 1.


题意:

小A喜欢挑战难题,给你一个n*n的矩阵 ,map[i][j],表示在做过第i题后去做j题,将花费map[i][j]的时间,每次他选择j题目花费时间>=i的花费时间。。

#include <iostream>
using namespace std;
const int Max=20;
int map[Max][Max];
int vis[Max];
int ans;
int n;
void dfs(int i,int t,int m)   //准备做i题,i题时间要求为t,做了m道题了
{
m++;
vis[i]=1;
if(m>ans)
{
ans=m;
}
if(m>=n)
{
return;
}
for (int k=0; k<n; k++)
{
if(!vis[k] && map[i][k]>=t)
{

dfs(k, map[i][k], m);   //做k题

}
}
vis[i]=0;
return;
}
int main()
{
while (cin>>n)
{
ans=0;
memset(vis, 0, sizeof(vis));
for (int i=0; i<n; i++)
{
for (int j=0; j<n; j++)
{
cin>>map[i][j];
}
}
dfs(0, 0, 0);
cout<<ans<<endl;
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: